#!/bin/bash -ex

DIR="$( cd "$( dirname "$0" )" && pwd )"
. "$DIR/cloud-create.sh"

usage() {
    cat <<-EOF
USAGE: 
    $0 AMI [SCRIPT ..]
    $0

AMI       = canonistack AMI to use (run without options to list available)
SCRIPT    = any number of "hack" scripts to run on the server as root

The hack scripts need to be as named as is and in the deployment directory.
They will be executed as the super user on the remote system after the
deployment is finished.

At the moment, this script is designed only to work on Canonistack.
EOF
}

if [ "$1" == "" ]; then
    usage
    echo
    echo "Please pass in an image or ubuntu series name to use:"
    get_images
    exit 1;
fi

AMI=$1
shift

echo "* Creating LDS server: $AMI $PUBLIC_IP"
create_instance $AMI $PUBLIC_IP
bootstrap

echo "* Running any 'hack' scripts."
for script in $@; do
    echo "    * Running: $script"
    srexec "cd /tmp && bash -xe /tmp/$script"
done
