#!/bin/bash -e

# Simple script to teardown instances by ip address.
# IP address.

DIR="$( cd "$( dirname "$0" )" && pwd )"
TMPOUT=`mktemp`
TMPOUT2=`mktemp`
trap "rm -rf $TMPOUT $TMPOUT2" EXIT

SUCCESS=0
for (( i=0; i < 20; i++ )); do
    if euca-describe-instances | grep INSTANCE > $TMPOUT; then
        instances=$(cat $TMPOUT | awk -F "\t" '{ print $2 }')
        for instance in $instances; do
            ip=$($DIR/get-ip-of-instance $instance)
            echo $ip $instance >> $TMPOUT2
        done
        SUCCESS=1
        break
    fi
done

[ $SUCCESS -eq 0 ] && echo "Error listing instances (!)" && exit 1


for ip in $*; do
    echo $ip;
    if grep $ip $TMPOUT2; then
        instance=$(cat $TMPOUT2 | grep $ip | awk '{ print $2 }')
        echo " * Removing Instance: $instance"
        euca-terminate-instances $instance
    else
        echo " * $ip not running, skipping"
    fi
done;
