#!/usr/bin/python

import jenkins
import os
from difflib import Differ
import pycurl

JENKINS = "http://localhost:8080"

def update_config(job_name, config):
    c = pycurl.Curl()
    c.setopt(c.URL, "%s/job/%s/config.xml" % (JENKINS, job_name))
    c.setopt(pycurl.POST, 1)
    c.setopt(pycurl.POSTFIELDS, str(config))
    headers = ["Content-Type: text/xml"]
    c.setopt(pycurl.HTTPHEADER, headers)
    c.perform()

j = jenkins.Jenkins('http://localhost:8080')
d = Differ()
for job_name in os.listdir("jobs"):
    with open ("jobs/%s/config.xml" % job_name, "r") as f:
        scm_config = f.read()

    if not j.job_exists(job_name):
        print "New Job: %s" % job_name
        j.create_job(job_name, scm_config)
        continue

    existing_config = j.get_job_config(job_name)

    if existing_config != scm_config:
        print "%s Diff: Jenkins vs. SCM:" % job_name
        for line in d.compare(
            existing_config.splitlines(1), scm_config.splitlines(1)):
            print line
        print "Updating config in %s" % job_name
        j.enable_job(job_name)
        update_config(job_name, scm_config)
