import os
from novaclient.client import Client
import swiftclient

class Openstack(object):
    def __init__(self):
        username = os.getenv('OS_USERNAME')
        tenant_name = os.getenv('OS_TENANT_NAME')
        password = os.getenv('OS_PASSWORD')
        auth_url = os.getenv('OS_AUTH_URL')
        region = os.getenv('OS_REGION_NAME')

        self.swift = swiftclient.client.Connection(
                authurl=auth_url, user=username, key=password,
                auth_version=2.0,
                os_options={'tenant_name': tenant_name, 'region_name': region})

        self._server_service = Client(
                1.1,
                username,
                password,
                tenant_name,
                auth_url,
                False,
                region_name=region
                )
        self._snapshot_service = Client(
                1.1,
                username,
                password,
                tenant_name,
                auth_url,
                False,
                region_name=region,
                service_type="snapshot"
                )
        self._volume_service = Client(
                1.1,
                username,
                password,
                tenant_name,
                auth_url,
                False,
                region_name=region,
                service_type="volume"
                )
        self.servers = self._server_service.servers
        self.volumes = self._volume_service.volumes
        self.volume_snapshots = self._volume_service.volume_snapshots
